﻿using ArcGIS.Core.CIM;
using ArcGIS.Core.Data;
using ArcGIS.Core.Geometry;
using ArcGIS.Desktop.Catalog;
using ArcGIS.Desktop.Core;
using ArcGIS.Desktop.Editing;
using ArcGIS.Desktop.Extensions;
using ArcGIS.Desktop.Framework;
using ArcGIS.Desktop.Framework.Contracts;
using ArcGIS.Desktop.Framework.Dialogs;
using ArcGIS.Desktop.Framework.Threading.Tasks;
using ArcGIS.Desktop.Layouts;
using ArcGIS.Desktop.Mapping;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CustomAttributeTab
{
    internal class RemoveActivation : Button
    {
        protected override void OnClick()
        {
            var featureLayers = MapView.Active?.Map.GetLayersAsFlattenedList().OfType<FeatureLayer>();
            var standaloneTable = MapView.Active?.Map.GetStandaloneTablesAsFlattenedList();
            if (featureLayers.Count() == 0) return;
            Guid myExtension = new Guid("{f019fd26-4824-45d8-9788-2a0746973b31}");
            QueuedTask.Run(() => {
                foreach (var featureLayer in featureLayers)
                {
                    var fc = featureLayer.GetFeatureClass();
                    fc.RemoveActivationExtension(myExtension);
                }
                if (standaloneTable.Count() == 0) return;
                var table = standaloneTable.FirstOrDefault().GetTable();
                table.RemoveActivationExtension(myExtension);
            });
        }
    }
}
